#line 1 ".\Src\main.c"
#line 1 "D:\C\include\SonixDef.h"



unsigned long GetRollingCode(unsigned int offset);








struct _intrinsicbitfield
{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};













#line 1 ".\Src\main.c"
#line 1 ".\Include\FC2720.h"


#line 6 ".\Include\FC2720.h"









struct bitRegister{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};

typedef unsigned char BYTE;
typedef unsigned long WORD;
typedef double DWORD;






sfr	R = 0x82;
sfr	Z = 0x83;
sfr	Y = 0x84;
sfr	PFLAG = 0x86;

sbit	LVDF =0x86:5;















 sfr    TM1M    =0XA0;
 sfr    TM1C   =0XA1;
 sfr    TM1D0   =0XA2;
 sfr    TM1D1  =0XA3;
 sfr    TM1D2  =0XA4;
 sfr    TM1D3  =0XA5;
 sfr    PWM1E   =0XA6;

 sfr	I2CCON	=0XA8;
 sfr	I2CADD	=0XA9;
 sfr	I2CBUF	=0XAA;

 sfr    TM2M    =0XB0;
 sfr    TM2C   =0XB1;
 sfr    TM2D0   =0XB2;
 sfr    TM2D1  =0XB3;
 sfr    TM2D2  =0XB4;
 sfr    TM2D3  =0XB5;
 sfr    PWM2E   =0XB6;


 sfr    E2PCON =0Xab;
 sfr    E2PDB  =0Xac;
 sfr    E2PADL =0Xad;
 sfr    E2ADH  =0Xae;

 sfr    TKCON=  0X88;
 sfr    TKTMD =0X89;
 sfr    TKTMCH =0X8B;
 sfr    TKTMCL =0X8C;
 sfr    TKTMRH =0X8D;
 sfr    TKTMRL =0X8E;
 sfr    TKMIO  =0X8F;

 sfr    ADM =0XB9;
 sfr    ADB =0XBa;
 sfr    ADR =0XBb;
 sfr    ADT =0XBc;
 sfr    VREFH =0XBd;
 sfr    ADPCON =0XBe;
 sfr	PEDGE =0XBF;

 sfr    P1W = 0XC0;
 sfr	P1M = 0xc1;
 sfr	P3M=0XC3;
 sfr    INTRQ1 = 0XC6;
 sfr    INTEN1 = 0XC7;
 sfr    INTRQ = 0XC8;
 sfr    INTEN = 0XC9;
 sfr	OSCM = 0xca;
 sfr	RCADJ =0XCB;
 sfr	WDTR =0XCC;
 sfr    OPTION = 0XCD;
 sfr	PCL =0XCE;
 sfr	PCH =0XCF;

 sfr	P1 = 0XD1;
 sfr	P2 = 0XD2;
 sfr	P3 = 0XD3;
 sfr	T0M = 0XD8;
 sfr	T0C = 0XD9;
 sfr    OPA1CON = 0XDA;
 sfr    OPA2CON = 0XDB;
 sfr    P1OD = 0XDC;
 sfr    P3W = 0XDE;
 sfr    STKP = 0XDF;

 sfr	P1UR=0Xe1;
 sfr	P2UR=0XE2;
 sfr	P3UR=0XE3;

 sfr	P1PD=0XEC;
 sfr	P3PD=0XEE;

sbit	FP37UR = 0XE3:7;

sbit	E2P_ER_HALF =0xAB:5;
sbit	E2P_BER	    =0xAB:4;
sbit	E2P_CER	    =0xAB:3;
sbit	E2P_SER		=0xAA:2;
sbit	E2P_PG		=0xA9:1;
sbit	E2P_RD		=0xA8:0;

sbit	SPIEN		=0x98:0;

sbit	WCOL		=0x99:1;
sbit	CSEN		=0x99:2;
sbit	MLS		=0x99:3;
sbit	CKEG		=0x99:4;
sbit	CKPOLB		=0x99:5;


sbit	I2CEN		=0xA8:0;
sbit	I2CPU		=0xA8:1;
sbit	I2CCKP		=0xA8:2;
sbit	TXAK		=0xA8:3;
sbit	SRW		=0xA8:4;
sbit	HBB		=0xA8:5;
sbit	HAAS		=0xA8:6;
sbit	HCF		=0xA8:7;



sbit	WDTP0		=0xCD:0;
sbit	WDTP1		=0xCD:1;
sbit	WDTP2		=0xCD:2;
sbit	RTCCON		=0xCD:3;
sbit	LVDTEN		=0xCD:4;
sbit	LDOEN		=0xCD:5;
sbit	LIRC_EN		=0xCD:6;
sbit	RCADJEN		=0xCD:7;




sbit	FCHS0		=0xB9:0;
sbit	FCHS1		=0xB9:1;
sbit	FCHS2		=0xB9:2;
sbit	FCHS3		=0xB9:3;
sbit	FGCHS		=0xB9:4;
sbit	FEOC		=0xB9:5;
sbit	FADS		=0xB9:6;
sbit	FADENB		=0xB9:7;



sbit	FADCKS0		=0xBB:4;
sbit	FADCKS1		=0xBB:6;



sbit	FADT_0		=0xBc:0;
sbit	FADT_1		=0xBC:1;
sbit	FADT_2		=0xBC:2;
sbit	FADT_3		=0xBC:3;
sbit	FADT_4		=0xBC:4;

sbit	Fadts_0		=0xBC:6;
sbit	Fadts_1		=0xBC:7;


sbit	FVHS0		=0xBD:0;
sbit	FVHS1		=0xBD:1;

sbit	FEVHENB		=0xBD:7;



sbit    PWM20OE     =0xB6:4;
sbit    PWM21OE     =0xB6:5;
sbit    PWM21E      =0xB6:1;




sbit	FINT0IE		=0xc9:0;
sbit	FINT1IE		=0xc9:1;
sbit	FTM0IE		=0xc9:2;
sbit	FTM1IE		=0xc9:3;
sbit	FTM2IE		=0xc9:4;
sbit	FRPIE		=0xc9:5;
sbit	FI2CIE		=0xc9:6;
sbit	FADCIE		=0xc9:7;

sbit	FE2PIE		=0xc7:0;
sbit	FTKTMRIE	=0xc7:1;
sbit	FSPIIE		=0xc7:2;
sbit	FT0IE	    =0xC7:3;
sbit	FOPAIE    	=0xC7:4;

sbit	FINT0IF		=0xc8:0;
sbit	FINT1IF		=0xc8:1;
sbit	FTM0IF		=0xc8:2;
sbit	FTM1IF		=0xc8:3;
sbit	FTM2IF		=0xc8:4;
sbit	FRPIF		=0xc8:5;
sbit	FI2CIF		=0xc8:6;
sbit	FADCIF		=0xc8:7;

sbit	FE2PIF		=0xc6:0;
sbit	FTKTMRIF	=0xc6:1;
sbit	FSPIIF		=0xc6:2;
sbit	FT0IF	    =0xC6:3;
sbit	FOPAIF    	=0xC6:4;


sbit	FGIE = 0xdf:7;


sbit	FP17 = 0xd1:7;
sbit	FP16 = 0xd1:6;
sbit	FP15 = 0xd1:5;
sbit	FP14 = 0xd1:4;
sbit	FP13 = 0xd1:3;
sbit	FP12 = 0xd1:2;
sbit	FP11 = 0xd1:1;
sbit	FP10 = 0xd1:0;


sbit	FP37 = 0xd3:7;
sbit	FP36 = 0xd3:6;
sbit	FP35 = 0xd3:5;
sbit	FP34 = 0xd3:4;
sbit	FP33 = 0xd3:3;
sbit	FP32 = 0xd3:2;
sbit	FP31 = 0xd3:1;
sbit	FP30 = 0xd3:0;













#line 2 ".\Src\main.c"

enum status
{
  POWER_ON,DANGWEI,CHRGING,SLEEPING
};


































bit       bit1ms=0;
bit       bit5ms=0;
bit       bit8ms=0;
bit       bit10ms=0;
bit       bit10ms_1=0;
bit       bit200ms=0;

bit       bitshorton=0;
bit       bitkey_short=0;

bit       bitkey_long=0;
bit       bitkeylock1=0;
bit       bitkeylock2=0;
bit       bitChrg=0;
bit       bitChek=0;




bit       bit11=0;
bit       bit1=0;
bit       bit2=0;
bit       bit3=0;
bit       bitmode=0;

bit     bit_chose=0;
bit  	bit_hu_shan=0;
bit  	bit_pwm_3d=0;
bit  	bit_lowpower=0;
bit     bit_led_s=0;
bit     bit_pwm_en=0;
bit     bit_pwm_3=0;

bit       bit17=0;






#line 95 ".\Src\main.c"

 unsigned char   u8AdcLast;
 unsigned char   u8AdcNow;
 unsigned char   u8AdcFilterValue;
 unsigned char   cnt;


 unsigned char    u8Mode=0;
 unsigned char    u8Duty=0;

 unsigned char    TM1D3_T=0;
 unsigned char    TM1C_T=0;

 unsigned char    g=0,x=0,e=0,y=0,s=0,i=0,v=0,k=0,w=0;
 unsigned long int   a=0,b=0,c=0,d=0,f=0;

enum status u8Status=SLEEPING;

void delay_1ms(unsigned char x_1ms);

void SysInit(void);
void scan_key(void);

void Get_ADC(void);
void time_jiange(void);
void t0_enable(void);
void pwm_disable(void);
void pwm20_enable(void);
void pwm21_enable(void);
void ADC_Init(void);

void pwm13_disable(void);
void pwm13_enable(void);


#line 137 ".\Src\main.c"
void __interrupt[0x8] isr(void)
{
  static unsigned char j=0,h=0,u=0;

  if(FT0IF)
  {
	FT0IF=0;
    T0C=68;
    bit1ms=1;
    j++;
    h++;
	u++;
	if(j>4)
	{
	  j=0;
	  bit5ms=1;
	 }
    if(u>9)
	{
	  u=0;
	  bit10ms=1;
	  bit10ms_1=1;
	 }
    if(h>199)
    {
	  h=0;
      bit200ms=1;
    }


  }
  INTRQ=0;
  INTRQ1=0;
}

#line 179 ".\Src\main.c"
void main(void)
{
    SysInit();
    u8Status=SLEEPING;
	bit1ms=0;
	u8Mode=1;
	ADC_Init();
	for(c=0;c<200;c++)
	{
	  delay_1ms(1);
	  Get_ADC();
     }





    while(1)
    {
		WDTR=0X5A;

		switch(u8Status)
		{

#line 237 ".\Src\main.c"


		  case  DANGWEI:
		    WDTR=0X5A;
		   if(bit1ms)
		   {
		      bit1ms=0;
			  Get_ADC();
			  scan_key();
              if(bitChrg==0)
			  {
 FP12 =1;
 FP13 =1;
			     pwm13_disable();
				 bit_hu_shan=1;
				 a=0;
			     u8Status=CHRGING;

				 break;
               }
			  if(bitkey_long)
			  {
			     bitkey_long=0;

				 pwm13_disable();
				 u8Status=SLEEPING;
				 break;
              }
			  if(u8AdcFilterValue< 179)
			  {
			       g++;
				   if(g>20)
				   {
				      g=0;
				      pwm13_disable();
					  bit_lowpower=1;
                    }
               }
			   else
			   {
			       g=0;
                }

              if(bit_lowpower)
                {
			     if(bit10ms)
				 {
				    bit10ms=0;
					a++;
					if(a>50)
					{
					   a=0;
					   if(bit_hu_shan)
					   {
 FP12 =1;
 FP13 =0;
                       bit_hu_shan=0;
					   }
                       else
					   {
 FP12 =0;
 FP13 =1;
                       bit_hu_shan=1;
					   }

#line 308 ".\Src\main.c"
                     }
			       }

                }
               else
			   {
			   if(bitkey_short)
			  {
			     bitkey_short=0;
				 u8Mode++;
				 bit_chose=1;
				 if(u8Mode>3)
				 {
				   u8Mode=4;
                  }
              }
			  if(bit_chose)
			  {
			     bit_chose=0;
			     switch(u8Mode)
			     {
			       case 1:
				        TM1D3_T=227;
						TM1C_T=115;
				        pwm13_enable();
						d=0;e=0;
						bit_led_s=1;
                        bit_pwm_en=1;
						bit_pwm_3d=0;
 FP12 =1;
 FP13 =1;
					    break;

                   case 2:
				         TM1D3_T=255;
						 TM1C_T=115;
						 pwm13_enable();
						 d=0;e=0;
						 bit_led_s=1;
                         bit_pwm_en=1;
						 bit_pwm_3d=0;
 FP12 =1;
 FP13 =1;
						 break;
                   case 3:
				         TM1D3_T=227;
						 TM1C_T=115;
				         pwm13_enable();
						 d=0;e=0;
						 bit_led_s=1;
                         bit_pwm_en=1;
						 bit_pwm_3d=1;
						 bit_pwm_3=1;
 FP12 =1;
 FP13 =1;
						 break;
				   case  4:
				         u8Mode=1;
				         pwm13_disable();
						 u8Status=SLEEPING;
						 break;
				   }
               }

			   if(bit10ms_1)
			   {
			      bit10ms_1=0;
                  if(bit_led_s)
			     {
                  b++;
				  if(b>19)
				  {
				    b=0;
			        d++;
					P1^=0X0C;
					if(d>2)
					{
					  d=0;
                      bit_led_s=0;
                     }
                   }
                  }
                }
			   if(bit200ms)
			   {
			      bit200ms=0;
                  if(bit_pwm_3d)
				  {
				      if(bit_pwm_3)
					  {
					     pwm13_disable();
						 bit_pwm_3=0;
                      }
					  else
					  {
					     TM1D3_T=227;
						 TM1C_T=115;
					     pwm13_enable();
						 bit_pwm_3=1;
                      }
                  }

				  if(bit_pwm_en)
				 {
				    e++;
				    if(e>199)
				  {
                     e=0;
					 pwm13_disable();
                     bit_pwm_en=0;
					 bit_pwm_3d=0;
 FP12 =1;
 FP13 =1;
                   }
				  }
                }
               }
                   }
				   break;

		   case CHRGING:
                  WDTR=0X5A;
		          if(bit1ms)
				  {
				    bit1ms=0;
					scan_key();

#line 443 ".\Src\main.c"
				  if(bitChrg==0)
				  {
				   if(bit10ms)
				   {
				    bit10ms=0;
					a++;
					if(a>20)
					{
					   a=0;
					   if(bit_hu_shan)
					   {
 FP12 =1;
 FP13 =0;
                       bit_hu_shan=0;
					   }
                       else
					   {
 FP12 =0;
 FP13 =1;
                       bit_hu_shan=1;
					   }

#line 471 ".\Src\main.c"
                     }
			       }
                   }
                   else
				   {
				     u8Status=SLEEPING;
					}
					}
					break;

		  case SLEEPING:
		  SysInit();

          for(x=0;x<10;x++)
          {

		    WDTR=0X5A;
            if(bitkeylock1)x=0;

            scan_key();
            delay_1ms(1);
          }
		  bitkey_short=0;
          bitkey_long=0;
		  SysInit();

#line 500 ".\Src\main.c"
		  INTEN=0x20;
		  do
		  {
 __asm{SleepMode};
		  }while(FP30 && FP32);
		  INTEN=0x00;


          if(FP30 ==0)
		  {

			bitChrg=0;
	        u8Status=CHRGING;
			a=0;
            bit_hu_shan=1;

	        t0_enable();
	        break;
	      }

	      if(FP32 ==0)
	      {
	        x=0;
	        while(1)
	        {
	          x++;
              if(FP32 ==0)x=0;
              if(x>2)break;

			  WDTR=0X5A;
	          delay_1ms(1);

       	      scan_key();
			  if(bitkey_short)
			  {
				bitkey_short=0;
				bitkey_long=0;
	            a=0,b=0,c=0,d=0,e=0,g=0;
		        bit_chose=1;
				bit_hu_shan=1;
				bitChrg=1;
				bit_pwm_3d=0;
				bit_lowpower=0;
			    ADC_Init();
                t0_enable();

#line 550 ".\Src\main.c"
			    u8Status=DANGWEI;
                break;
			  }
	        }
	      }
		  break;
		}
	}
}

#line 567 ".\Src\main.c"
void ADC_Init(void)
{


  ADPCON=0x02;
  VREFH=0x00;
  ADR=0x20;
  ADM  =0x91;
}

#line 584 ".\Src\main.c"

#line 599 ".\Src\main.c"

void pwm13_enable(void)
{


  TM1D0=TM1D3_T;
  TM1C=TM1C_T;
  PWM1E=0x10;
  TM1M=0x93;
}

void  pwm13_disable(void)
{

   PWM1E=0x00;
   TM1M=0x00;
 FP11 =0;
}

#line 627 ".\Src\main.c"
void scan_key(void)
{
  static unsigned long int u8Count1=0;
  static unsigned char u8Count2=0;
  static unsigned char u8Count3=0;
  static unsigned char u8Count4=0;
  static unsigned char u8Count5=0;
  static unsigned char u8Count6=0;






#line 658 ".\Src\main.c"

  if(FP30)
  {
      u8Count5++;
	  if(u8Count5>30)
	  {
       u8Count5=0;
       bitChrg=1;
	   }
   }
   else
   {
      u8Count6++;
	  if(u8Count6>30)
	  {
       u8Count6=0;
       bitChrg=0;
	   }
   }


  if(FP32)
  {
      u8Count1=0;
      bitkeylock1=0;
	  if(bitshorton==1)
	  {
	     bitshorton=0;
		 bitkey_short=1;
	  }
  }
  else if(bitkeylock1==0)
  {
    u8Count1++;
    if(u8Count1>30)
    {
	   bitshorton=1;
	}
    if(u8Count1>3000)
	{
	   u8Count1=0;
	   bitshorton=0;

	   bitkeylock1=1;
	   bitkey_long=1;
    }
	}


#line 721 ".\Src\main.c"

  }



#line 733 ".\Src\main.c"

#line 764 ".\Src\main.c"


#line 773 ".\Src\main.c"
void Get_ADC(void)
{
  u8AdcLast=u8AdcNow;
  FADS =1;
  while(FADS);
  u8AdcNow=ADB;
  if(u8AdcLast==u8AdcNow)
  {
    cnt++;
    if(cnt>4)
    {
      cnt=0;
	  u8AdcFilterValue=u8AdcNow;
    }
  }
  else
  {
    cnt=0;
  }
}

#line 814 ".\Src\main.c"

#line 822 ".\Src\main.c"
void delay_1ms(unsigned char x_1ms)
{
 unsigned char i=0;
  WDTR=0x5A;
  for(;x_1ms>0;x_1ms--)
  {
    for(i=249;i>0;i--)
	{
      __asm{nop};
	  __asm{nop};
	  __asm{nop};
	  __asm{nop};
      __asm{nop};
      __asm{nop};
    }
  }
}

#line 849 ".\Src\main.c"
void t0_enable(void)
{
  T0M=0xC0;
  T0C=68;
  FT0IE=1;
  FGIE=1;
}

#line 866 ".\Src\main.c"
void t0_disable(void)
{
  T0M=0x00;
  FT0IE=0;
}

#line 879 ".\Src\main.c"
void SysInit(void)
{
  ADPCON=0x00;
  ADR  =0x00;
  VREFH=0x00;
  ADM  =0x00;

  T0M=0x00;
  FT0IE=0;
  TM1M =0x00;
  TM2M =0x00;
  PWM1E=0x00;
  PWM2E=0x00;

  INTEN=0x00;

  INTRQ=0x00;
  INTEN1=0x00;
  INTRQ1=0x00;

  PEDGE=0x00;
  FGIE=0;
  OPTION=0x00;

  P1   =0x0C;
  P1M  =0xFF;
  P1W  =0x00;
  P1UR =0x00;
  P1PD =0x00;

  P3   =0x05;
  P3M  =0x00;
  P3W  =0x05;
  P3UR =0x05;
  P3PD =0x00;

}
