#include "FC2720.h"
#include  "adc.h"

#define   uint8_t  unsigned char
#define   uint16_t unsigned long int




ADCVAR adcBattery;   //صѹ  
ADCVAR adcadzz; //ת
ADCVAR adcadfz; //ת
/******************************************************************************************************
*      : ADC_Filter 
*      ܣADC˲
*  ڲ   
*  ڲ
*      ڣ2019.6.15
*      ߣ
******************************************************************************************************/
#define   N      8
void ADC_Filter(ADCVAR *adcvar)
{   
    if(adcvar->u8AdcNow==adcvar->u8AdcLast)
    {
	  switch(adcvar->u8Step)
	  {
		case 0:
		{
		  adcvar->sum=adcvar->u8AdcNow;
		  adcvar->min=adcvar->u8AdcNow;
		  adcvar->max=adcvar->u8AdcNow;
		  adcvar->cnt++;
		  adcvar->u8Step=1;
		}
		break;
	
		case 1:
		if(adcvar->u8AdcNow>adcvar->max)
		{
		  adcvar->max=adcvar->u8AdcNow;            //ֵ	
		}	
		else if(adcvar->u8AdcNow<adcvar->min)
		{
		  adcvar->min=adcvar->u8AdcNow;		   //Сֵ
		}
		adcvar->sum+=adcvar->u8AdcNow;            //׷ӵֵ
		adcvar->cnt++;
		if(adcvar->cnt>(N-1))
		{	
		  adcvar->sum=adcvar->sum-adcvar->max-adcvar->min;//ƽֵ=(ֵ-ֵ-Сֵ)/(г-2)
		  adcvar->u8AdcFilterValue=adcvar->sum/(N-2);  
		  adcvar->cnt=0;
		  adcvar->u8Step=0;	   			  
		}
		break;
	 
		default:
		{
		  adcvar->cnt=0;
		  adcvar->u8Step=0;
		}
		break;
	  }  		  		
    }		
}
/******************************************************************************************************
*      : Get_ADC 
*      ܣѯADCתģʽ,жģʽ
*  ڲ   
*  ڲ
*      ڣ2019.7.1
*      ߣ
******************************************************************************************************/
//#define EOC ADC_CSR_EOC
//#define ADS ADC_CR1_ADON
//#define ADB ADC_DRH
//#define ADR ADC_DRL
void Get_ADC(ADCVAR *adcvar)
{
  adcvar->u8AdcLast=adcvar->u8AdcNow;
  FADS  =1;            //ʼADCת
  while(FADS);     //ȴADCת
  adcvar->u8AdcNow=ADB;         
  //adcvar->u8AdcNow<<=4;
  //adcvar->u8AdcNow +=(ADR&0x0F);
  FEOC=0;             //ADC״̬־λ׼һADC 
}
/******************************************************************************************************
*      : void read_adc_chs(void) 
*      ܣѯADCͨ
*  ڲ   
*  ڲ
*      ڣ2018.1.4
*      ߣ
******************************************************************************************************/
void read_adc_chs(void)
{
  static uint8_t step=0;	
  switch(step)
  {
	case 0:
	{
      Get_ADC(&adcBattery);		
	  ADC_Filter(&adcBattery);
//	  ADR=0x20;	  	  
	  ADM=0x93;	
	  step=1;		  
	}	
	break;
	  
	case 1:
	{
      Get_ADC(&adcadzz);			
	  ADC_Filter(&adcadzz);
//	  ADR=0x20;	  
	  ADM=0x92;			  
	  step=2;
	}	
	break;

	case 2:
	{
      Get_ADC(&adcadfz);			
	  ADC_Filter(&adcadfz);
//	  ADR=0x20;	  
	  ADM=0x96;			  
	  step=0;
	}	
	break;
	  
	default:
	{
//	  ADR=0x20;	  
	  ADM=0x96;			  
	  step=0;		
	}
  }	
}

